<template>

<div
    v-if="threshold"
    class="
    border-3
    lg:border-4
    bg-gray-200
    dark:bg-cgray-800
    border-gray-200
    dark:border-cgray-800
    rounded-lg
    p-2
    lg:p-4
    mt-2
">
    <div class="flex items-center">
        <b class="pr-4">{{ $t('type') }}</b>

        <div
            v-bind:class="{ 'opacity-50': threshold.state != THRESHOLD_STATE.GRADIENT }"
            v-on:click="
                threshold.state = THRESHOLD_STATE.GRADIENT
                project.update()
            "
            class="flex-1 cursor-pointer hover:opacity-100"
        >
            <span
                class="block h-8 w-full rounded-lg border-2 border-gray-600"
                v-bind:style="{ background: gradient() }"
            ></span>
        </div>

        <div
            v-bind:class="{ 'opacity-50': threshold.state != THRESHOLD_STATE.DOUBLE }"
            v-on:click="
                threshold.state = THRESHOLD_STATE.DOUBLE
                project.update()
            "
            class="flex-1 cursor-pointer flex ml-4 hover:opacity-100"
        >
            <span
                class="flex-1 h-8 w-full border-gray-600 rounded-tl-lg
                    rounded-bl-lg border-t-2 border-b-2 border-l-2 border-r"
                v-bind:style="{ background: threshold.goodColor }"
            ></span>
            <span
                class="flex-1 h-8 w-full border-gray-600 rounded-tr-lg
                    rounded-br-lg border-t-2 border-b-2 border-r-2 border-l"
                v-bind:style="{ background: threshold.badColor }"
            ></span>
        </div>

        <div
            v-bind:class="{ 'opacity-50': threshold.state != THRESHOLD_STATE.TRIPLE }"
            v-on:click="
                threshold.state = THRESHOLD_STATE.TRIPLE
                project.update()
            "
            class="flex-1 cursor-pointer flex ml-4 hover:opacity-100"
        >
            <span
                class="flex-1 h-8 w-full border-gray-600 rounded-tl-lg
                    rounded-bl-lg border-t-2 border-b-2 border-l-2 border-r"
                v-bind:style="{ background: threshold.goodColor }"
            ></span>
            <span
                class="flex-1 h-8 w-full border-gray-600 border-t-2 border-b-2 border-r border-l"
                v-bind:style="{ background: threshold.middleColor }"
            ></span>
            <span
                class="flex-1 h-8 w-full border-gray-600 rounded-tr-lg
                    rounded-br-lg border-t-2 border-b-2 border-r-2 border-l"
                v-bind:style="{ background: threshold.badColor }"
            ></span>
        </div>
    </div>

    <BoxInput/>
</div>

</template>

<script lang='ts'>

import { Component, Vue } from 'vue-property-decorator';
import { State } from 'vuex-class';

import { Project } from '@/ts/project';
import { STATE, Threshold } from '@/ts/threshold';

import BoxInput from './components/BoxInput.vue';

@Component({
    components: {
        BoxInput,
    },
})
export default class VueComponent extends Vue {
    @State('project')
    private project!: Project;

    private THRESHOLD_STATE = STATE;

    private threshold: Threshold | null = null;

    private mounted() {
        if (
            this.project
            && this.project.reports
            && this.project.reports.current
            && this.project.reports.current.thresholds
            && this.project.reports.current.thresholds.current
        ) {
            this.threshold = this.project.reports.current.thresholds.current;
        }
    }

    private gradient(): string {
        if (this.threshold) {
            return `linear-gradient(90deg,${this.threshold.goodColor},${this.threshold.badColor})`;
        }
        return '#ffffff';
    }
}

</script>
